"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Theme = require("../../providers/Theme");

var _Menu = require("../../providers/Menu");

var _iconsMaterial = require("@mui/icons-material");

var _material = require("@mui/material");

var _reactRouterDom = require("react-router-dom");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var SelectableMenuList = function SelectableMenuList(_ref) {
  var onIndexChange = _ref.onIndexChange,
      useMinified = _ref.useMinified,
      items = _ref.items,
      index = _ref.index;

  var _useState = (0, _react.useState)({}),
      state = _useState[0],
      setState = _useState[1];

  var _useAppTheme = (0, _Theme.useTheme)(),
      isRTL = _useAppTheme.isRTL;

  var _useMenu = (0, _Menu.useMenu)(),
      isMiniMode = _useMenu.isMiniMode;

  var _useLocation = (0, _reactRouterDom.useLocation)(),
      _useLocation$pathname = _useLocation.pathname,
      pathname = _useLocation$pathname === void 0 ? '' : _useLocation$pathname;

  var loopItems = (0, _react.useCallback)(function (items, previousItems, title) {
    if (previousItems === void 0) {
      previousItems = [];
    }

    items.map(function (i) {
      var _i$value = i.value,
          value = _i$value === void 0 ? 'none' : _i$value,
          _i$nestedItems = i.nestedItems,
          nestedItems = _i$nestedItems === void 0 ? [] : _i$nestedItems,
          _i$primaryText = i.primaryText,
          primaryText = _i$primaryText === void 0 ? '' : _i$primaryText;

      if (pathname === value) {
        if (previousItems.length) {
          setState({
            index: value,
            previousItems: [previousItems],
            items: items,
            title: title
          });
        } else {
          setState({
            index: value
          });
        }

        return i;
      }

      if (nestedItems.length) {
        loopItems(nestedItems, [].concat(previousItems, [items]), primaryText);
      } //console.log('i', i)


      return i;
    }); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  var list = state.previousItems && state.previousItems.length > 0 ? state.items : items;
  (0, _react.useEffect)(function () {
    loopItems(items); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []); //Clears nested state if the root items change
  //Used to open auth menu if we are in a nested menu
  //We use just the length because the auth menu has always less items

  (0, _react.useEffect)(function () {//setState({})
  }, [items.length]);

  var handleNestedItemsClick = function handleNestedItemsClick(item) {
    if (item.nestedItems) {
      var previousItems = state.previousItems || [];
      var previousTitles = state.previousTitles || [];
      var _items = item.nestedItems;
      var title = item.primaryText;
      previousItems.unshift(state.items || _items);
      previousTitles.unshift(state.title || title);
      setState(_extends({}, state, {
        items: _items,
        previousItems: previousItems,
        previousTitles: previousTitles,
        title: title,
        index: item.value
      }));
    } else {
      if (item.value || item.onClick) {
        setState(_extends({}, state, {
          index: item.value
        }));
      }
    }
  };

  var handleBackClick = function handleBackClick() {
    var previousItems = state.previousItems || [];
    var previousTitles = state.previousTitles || [];
    var items = previousItems[0] || undefined;
    var title = previousTitles[0] || undefined;
    previousItems.shift();
    previousTitles.shift();
    setState(_extends({}, state, {
      items: items,
      previousItems: previousItems,
      previousTitles: previousTitles,
      title: title
    }));
  };

  var getItem = function getItem(item, i) {
    var index = state.index;
    delete item.visible;

    if (item !== undefined) {
      if (item.subheader !== undefined) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: i,
          inset: item.inset,
          style: item.style
        }, item.subheader);
      } else if (item.divider !== undefined) {
        return /*#__PURE__*/_react["default"].createElement(_material.Divider, {
          key: i,
          inset: item.inset,
          style: item.style
        });
      } else {
        return /*#__PURE__*/_react["default"].createElement(_material.Tooltip, {
          disableFocusListener: true,
          disableTouchListener: true,
          disableHoverListener: !isMiniMode,
          "aria-label": item.primaryText,
          placement: isRTL ? 'left' : 'right',
          title: /*#__PURE__*/_react["default"].createElement(_material.Typography, {
            variant: "button",
            children: item.primaryText
          }),
          key: i
        }, /*#__PURE__*/_react["default"].createElement(_material.List, null, /*#__PURE__*/_react["default"].createElement(_material.ListItem, {
          disablePadding: true,
          selected: index && index === item.value,
          key: i,
          onClick: function onClick(e) {
            onIndexChange(e, item.value);
            handleNestedItemsClick(item);

            if (item.onClick) {
              item.onClick();
            }
          },
          onMouseDown: function onMouseDown(e) {
            if (e.button === 1) {
              var win = window.open("" + item.value, '_blank');
              win.focus();
            }
          }
        }, /*#__PURE__*/_react["default"].createElement(_material.ListItemButton, null, item.leftIcon && /*#__PURE__*/_react["default"].createElement(_material.ListItemIcon, null, item.leftIcon), !useMinified && /*#__PURE__*/_react["default"].createElement(_material.ListItemText, {
          primary: item.primaryText
        })), item.nestedItems && !useMinified && /*#__PURE__*/_react["default"].createElement(_material.ListItemSecondaryAction, {
          onClick: function onClick() {
            handleNestedItemsClick(item);
          }
        }, /*#__PURE__*/_react["default"].createElement(_material.IconButton, null, isRTL ? /*#__PURE__*/_react["default"].createElement(_iconsMaterial.KeyboardArrowLeft, null) : /*#__PURE__*/_react["default"].createElement(_iconsMaterial.KeyboardArrowRight, {
          sx: {
            color: function color(t) {
              return t.palette.text.primary;
            }
          }
        }))))));
      }
    }

    return null;
  };

  return /*#__PURE__*/_react["default"].createElement(_material.List, {
    value: index,
    onChange: onIndexChange
  }, state.items && state.previousItems && state.previousItems.length > 0 && /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_material.ListItem, {
    disablePadding: true,
    onClick: function onClick() {
      handleBackClick();
    }
  }, /*#__PURE__*/_react["default"].createElement(_material.ListItemButton, null, /*#__PURE__*/_react["default"].createElement(_material.ListItemIcon, null, /*#__PURE__*/_react["default"].createElement(_iconsMaterial.ArrowBack, null)), /*#__PURE__*/_react["default"].createElement(_material.ListItemText, {
    primary: state.title
  }))), /*#__PURE__*/_react["default"].createElement(_material.Divider, null)), list.length && list.filter(function (item) {
    return item.visible !== false;
  }).map(function (item, i) {
    return getItem(item, i);
  }));
};

var _default = SelectableMenuList;
exports["default"] = _default;
module.exports = exports.default;